varying highp vec2 textureCoordinate;
uniform sampler2D uTexture;

//uniform highp vec2 singleStepOffset;
uniform highp vec2 skinBlemishRemoval;
highp float hardLight(highp float color) {
    if (color <= 0.5)
    color = color * color * 2.0;
    else
    color = 1.0 - ((1.0 - color) * (1.0 - color)* 2.0);
    return color;
}

void main() {
    highp vec3 centralColor = texture2D(uTexture, textureCoordinate).rgb;
   /* vec2 skinBlemishRemoval=vec2(0.5,0.5);*/
    highp vec2 singleStepOffset=vec2(0.6/544.0,0.6/960.0);
    highp vec2 skinBlemishRemovalParam = skinBlemishRemoval;
    bool isSkin = false;
    highp vec4 rgb = texture2D(uTexture, textureCoordinate) * 255.0;
    highp vec4 ycbcr = rgb;
    ycbcr.x = 16.0 + rgb.x*0.257 + rgb.y*0.504 + rgb.z*0.098;
    ycbcr.y = 128.0 - rgb.x*0.148 - rgb.y*0.291 + rgb.z*0.439;
    ycbcr.z = 128.0 + rgb.x*0.439 - rgb.y*0.368 - rgb.z*0.071;
    if (ycbcr.y > 80.0 && ycbcr.y < 118.0 &&
    ycbcr.z > 121.0 && ycbcr.z < 171.0) {
        isSkin = true;
    }

    if (!isSkin) {
        skinBlemishRemovalParam = vec2(skinBlemishRemoval[0] * 0.9, skinBlemishRemoval[1]);
    }
    // 磨皮
    gl_FragColor = texture2D(uTexture, textureCoordinate
    );
    highp float mul_x = 2.0 * singleStepOffset[0];
    highp float mul_y = 2.0 * singleStepOffset[1];
    highp vec2 blurCoordinates0 = textureCoordinate + vec2(0.0 * mul_x, -10.0 * mul_y);
    highp vec2 blurCoordinates2 = textureCoordinate + vec2(8.0 * mul_x, -5.0 * mul_y);
    highp vec2 blurCoordinates4 = textureCoordinate + vec2(8.0 * mul_x, 5.0 * mul_y);
    highp vec2 blurCoordinates6 = textureCoordinate + vec2(0.0 * mul_x, 10.0 * mul_y);
    highp vec2 blurCoordinates8 = textureCoordinate + vec2(-8.0 * mul_x, 5.0 * mul_y);
    highp vec2 blurCoordinates10 = textureCoordinate + vec2(-8.0 * mul_x, -5.0 * mul_y);

    mul_x = 1.8 * singleStepOffset[0];
    mul_y = 1.8 * singleStepOffset[1];
    highp vec2 blurCoordinates1 = textureCoordinate + vec2(5.0 * mul_x, -8.0 * mul_y);
    highp vec2 blurCoordinates3 = textureCoordinate + vec2(10.0 * mul_x, 0.0 * mul_y);
    highp vec2 blurCoordinates5 = textureCoordinate + vec2(5.0 * mul_x, 8.0 * mul_y);
    highp vec2 blurCoordinates7 = textureCoordinate + vec2(-5.0 * mul_x, 8.0 * mul_y);
    highp vec2 blurCoordinates9 = textureCoordinate + vec2(-10.0 * mul_x, 0.0 * mul_y);
    highp vec2 blurCoordinates11 = textureCoordinate + vec2(-5.0 * mul_x, -8.0 * mul_y);

    mul_x = 1.6 * singleStepOffset[0];
    mul_y = 1.6 * singleStepOffset[1];
    highp vec2 blurCoordinates12 = textureCoordinate + vec2(0.0 * mul_x,-6.0 * mul_y);
    highp vec2 blurCoordinates14 = textureCoordinate + vec2(-6.0 * mul_x,0.0 * mul_y);
    highp vec2 blurCoordinates16 = textureCoordinate + vec2(0.0 * mul_x,6.0 * mul_y);
    highp vec2 blurCoordinates18 = textureCoordinate + vec2(6.0 * mul_x,0.0 * mul_y);

    mul_x = 1.4 * singleStepOffset[0];
    mul_y = 1.4 * singleStepOffset[1];
    highp vec2 blurCoordinates13 = textureCoordinate + vec2(-4.0 * mul_x,-4.0 * mul_y);
    highp vec2 blurCoordinates15 = textureCoordinate + vec2(-4.0 * mul_x,4.0 * mul_y);
    highp vec2 blurCoordinates17 = textureCoordinate + vec2(4.0 * mul_x,4.0 * mul_y);
    highp vec2 blurCoordinates19 = textureCoordinate + vec2(4.0 * mul_x,-4.0 * mul_y);

    highp float central;
    highp float gaussianWeightTotal;
    highp float sum;
    highp float sampler;
    highp float distanceFromCentralColor;
    highp float gaussianWeight;

    highp float distanceNormalizationFactor = 3.6;

    central = texture2D(uTexture, textureCoordinate).g;
    gaussianWeightTotal = 0.2;
    sum = central * 0.2;

    sampler = texture2D(uTexture, blurCoordinates0).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates1).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates2).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates3).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates4).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates5).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates6).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates7).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates8).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates9).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates10).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates11).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.09 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates12).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates13).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates14).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates15).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates16).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates17).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates18).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sampler = texture2D(uTexture, blurCoordinates19).g;
    distanceFromCentralColor = min(abs(central - sampler) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += sampler * gaussianWeight;

    sum = sum/gaussianWeightTotal;

    sampler = centralColor.g - sum + 0.5;

    // 高反差保留
    sampler = hardLight(sampler);
    sampler = hardLight(sampler);
    sampler = hardLight(sampler);
    sampler = hardLight(sampler);
    sampler = hardLight(sampler);
    //haobenli add
  /*  sampler = hardLight(sampler);
    sampler = hardLight(sampler);*/
    //end

    highp float aa = 1.0 + pow(sum, 0.3) * 0.09;
    highp vec3 smoothColor = centralColor * aa - vec3(sampler) * (aa - 1.0);
    smoothColor = clamp(smoothColor, vec3(0.0), vec3(1.0));

    smoothColor = mix(centralColor, smoothColor, pow(centralColor.g, 0.33));
    smoothColor = mix(centralColor, smoothColor, pow(centralColor.g, 0.39));

    smoothColor = mix(centralColor, smoothColor, skinBlemishRemovalParam[0]);

    gl_FragColor = vec4(pow(smoothColor, vec3(0.96)), 1.0);

    // 解决画面偏黄的问题
    gl_FragColor.r = log(1.0 + 0.1 * gl_FragColor.r)/ log(1.1);
    gl_FragColor.g = log(1.0 + 0.1 * gl_FragColor.g)/ log(1.1);
    gl_FragColor.b = log(1.0 + 0.2 * gl_FragColor.b)/ log(1.2);

    gl_FragColor.rgb = gl_FragColor.rgb * skinBlemishRemovalParam[1] + (1.0 - skinBlemishRemovalParam[1]) * centralColor; // 当磨皮参数为零时，消除磨皮效果

}



